%{!?_release: %define _release 6}
%{!?GDR_VERSION: %define GDR_VERSION 2.3}
%global debug_package %{nil}
%global buildforkernels newest
%global kmod_name gdrcopy

Name:           gdrcopy
Version:        %{GDR_VERSION}
Release:        %{_release}%{?dist}.8
Summary:        GDRcopy library and companion kernel-mode driver    
Group:          System Environment/Libraries
License:        MIT
URL:            https://github.com/NVIDIA/gdrcopy
Source0:        %{name}-%{version}.tar.gz
BuildRequires:  gcc kernel-headers check-devel
BuildRequires:	cudatoolkit110-devel nvidia-kmod-devel
Requires:       check kmod-%{kmod_name}

# to get rid of libcuda/libcudart
AutoReqProv:    no
Provides:	libgdrapi.so.2()(64bit)
# alternatives, not working on RH6 
#%filter_from_provides /libcuda\\.so.*$/d
#%global __provides_exclude ^libcuda\\.so.*$

BuildRequires:  %kernel_module_package_buildreqs
%kernel_module_package -n %{kmod_name}

%package devel
Summary: The development files
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}
AutoReqProv:    no

%description
GDRCopy, a low-latency GPU memory copy library and a kernel-mode driver, built on top of the 
NVIDIA GPUDirect RDMA technology.

%description devel
GDRCopy, a low-latency GPU memory copy library and a kernel-mode driver, built on top of the 
NVIDIA GPUDirect RDMA technology.

%prep
%setup
cd src
for flavor in %flavors_to_build ; do
  cp -a gdrdrv _kmod_build_${flavor}
done

%build
echo "building"
# Build all but the driver
make -j CUDA=/usr/local/cuda prefix=%{_prefix} libdir=%{_libdir} config lib exes

# and now driver, weak module style
for flavor in %flavors_to_build ; do
  pushd src/_kmod_build_${flavor}
    make %{?_smp_mflags} \
        KERNEL_UNAME="%{kernel_version $flavor}" KVER="%{kernel_version $flavor}" SYSSRC="%{kernel_source $flavor}" \
	NVIDIA_SRC_DIR=/usr/share/nvidia/devel \
        gdrdrv.ko
  popd
done


%install
make install DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} libdir=%{_libdir} CUDA=/usr/local/cuda config lib exes
#make drv_install DESTDIR=$RPM_BUILD_ROOT 
for flavor in %flavors_to_build ; do
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%kverrel${flavor%default}/extra/gdrcopy/
    install -D -m 0755 src/_kmod_build_${flavor}/*.ko $RPM_BUILD_ROOT/lib/modules/%kverrel${flavor%default}/extra/gdrcopy/
done

# Install gdrdrv service script
install -d $RPM_BUILD_ROOT/etc/init.d
install -m 0755 packages/rhel/init.d/gdrcopy $RPM_BUILD_ROOT/etc/init.d

%post
if ! ( /sbin/chkconfig --del gdrcopy > /dev/null 2>&1 ); then
   true
fi              

/sbin/chkconfig --add gdrcopy

#service gdrcopy start

%preun
service gdrcopy stop||:
if ! ( /sbin/chkconfig --del gdrcopy > /dev/null 2>&1 ); then
   true
fi              

%postun
/usr/bin/systemctl daemon-reload

%files
%{_prefix}/bin/apiperf
%{_prefix}/bin/copybw
%{_prefix}/bin/copylat
%{_prefix}/bin/sanity
%{_libdir}/libgdrapi.so.?.?
%{_libdir}/libgdrapi.so.?
/etc/init.d/gdrcopy


%files devel
%{_prefix}/include/gdrapi.h
%{_libdir}/libgdrapi.so
%doc README.md

%changelog
* Mon Sep 16 2019 Pak Markthub <pmarkthub@nvidia.com> 2.0-3
- Harden security in gdrdrv.
- Enable cached mappings in POWER9.
- Improve copy performance with unrolling in POWERPC.
- Creates _sanity_ unit test for testing the functionality and security.
- Consolidate basic and _validate_ into sanity unit test.
- Introduce compile time and runtime version checking in libgdrapi.
- Improve rpm packaging.
- Introduce deb packaging for the userspace library and the applications.
- Introduce dkms packaging for the gdrdrv driver.
- Rename gdr_copy_from/to_bar to gdr_copy_from/to_mapping.
- Update README
* Thu Jul 26 2018 Davide Rossetti <davide.rossetti@gmail.com> 1.4-2
- bumped minor version
* Fri Jun 29 2018 Davide Rossetti <davide.rossetti@gmail.com> 1.3-2
- a few bug fixes
* Mon Feb 13 2017 Davide Rossetti <davide.rossetti@gmail.com> 1.2-2
- package libgdrcopy.so as well
- add basic test
* Thu Sep 15 2016 Davide Rossetti <davide.rossetti@gmail.com> 1.2-1
- First version of RPM spec

